//
//  XSPEC12  November 2003
//
//

#include "XSUser/Global/XSGlobal.h"  
#include "XSUser/Global/Global.h"
#include "XSUtil/Utils/XSutility.h"
#include "XSUtil/Parse/XSparse.h"
#include "XSstreams.h"      

int
XSGlobal::xsAutosave(ClientData cdata,Tcl_Interp* tclInterp,int objc, Tcl_Obj* CONST  objv[])
{
        char* cmd (static_cast<char*>(cdata));
        const string OFF ("off");
        if (objc == 1 ) 
        {
                printDocs(cmd,"?");
                return TCL_OK;       
        }
        else 
        {
                string arg(Tcl_GetString(objv[1]));
                if ( arg[0] == '?')
                {
                        printDocs(cmd,"?");
                        return TCL_OK;      
                }   
                else
                {
                        size_t f=0;
                        if ((f = XSutility::isInteger(arg)) != XSparse::NOTFOUND())
                        {    
                                tcout << "Auto-save frequency set to " << f << std::endl;
                                globalData->autoSaveFrequency(f);     
                        }    
                        else 
                        {
                                arg = XSutility::lowerCase(arg);
                                if ( arg.compare(0,std::min(arg.length(),OFF.length()),OFF) == 0)
                                {
                                        tcout << "Auto-save disabled " << std::endl;
                                        globalData->autoSaveFrequency(XSparse::NOTFOUND());
                                }
                                else
                                {
                                        printDocs(cmd,"?");
                                        return TCL_ERROR;
                                }
                                
                        }
                
                }
        }
        return TCL_OK;
}

